program x09f
    use plplot

    integer i, j
    integer, parameter :: xdim=99, ydim=100, nptsx=35, nptsy=46
    integer :: plparseopts_rc

    real :: w(xdim, ydim)
    real :: tr(6)

    real :: clevel(11) = (/ 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0. /)

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    tr = (/ 0., 0., 0., 0., 0., 0. /)

    do i=1,nptsx
        do j=1,nptsy
            w(i,j) = 0.
        enddo
    enddo

    call plinit
    call plcont(w(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel, mypltr)
    call plend

contains

    ! Callback function that relies on global tr.
    subroutine mypltr( x, y, xt, yt )

        ! These callback arguments must have exactly these attributes.
        real, intent(in) ::  x, y
        real, intent(out) :: xt, yt
        xt = tr(1)
        xt = tr(2)
        xt = tr(3)
        xt = tr(4)
        xt = tr(5)
        xt = tr(6)
        xt = tr(1) * x + tr(2) * y + tr(3)
        yt = tr(4) * x + tr(5) * y + tr(6)

    end subroutine mypltr

end program x09f
